#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <string.h>
#include "lrmi.h"
#include "lrmi.c"
//#define SHOWSTATE
int main(int argc, char *argv[])
{
  unsigned int PowerState=0x0000;
  unsigned int ReadWriteMode=0x0001;
  if ( argc == 2 ){
      /*
    Values for VESA VBE/PM power state:
     BL    STATE
     00h	On
     01h	standby
     02h	suspend
     04h	Off
     08h	reduced On (for flat screens)
    */
    if ( strncmp( argv[1],"normal",6 ) == 0 )
        PowerState=0x0000;
    else if ( strncmp(argv[1],"standby",7) == 0 )
        PowerState=0x0100;
    else if ( strncmp(argv[1],"suspend",7) == 0 )
        PowerState=0x0200;
    else if ( strncmp(argv[1],"poweroff",8) == 0 )
        PowerState=0x0400;
    else if ( strncmp(argv[1],"reduced",7) == 0 )
        PowerState=0x0800;
    else if ( strncmp(argv[1],"state",5) == 0 ) {
        ReadWriteMode=0x0002;
	#ifndef SHOWSTATE
	#define SHOWSTATE
	#endif
    }else {
        printf("Usage: %s [normal | standby | suspend | poweroff | reduced | state] \n",argv[0]);
        return 1;
    }
  }
   
  struct LRMI_regs r;
  if (!LRMI_init())
  return 1;
  /*
  Allow read/write to ALL io ports
  */
  ioperm(0, 1024, 1);
  iopl(3);
  
  memset(&r, 0, sizeof(r));
  r.eax = 0x4f10;
  r.ebx = ReadWriteMode | PowerState;
  if (!LRMI_int(0x10, &r)) 
  {
    fprintf(stderr, "Can't get output device info\n");
    return 1;
  }
#ifdef    SHOWSTATE
  printf("[AX]=%x\n",r.eax);
  printf("[BH]=%x,[BL]=%x\n",r.ebx>>8,r.ebx&0xf);
#endif
  	
  return 0;
}
