#include <iostream>
#include "setDisplay.h"

using namespace std;

setDisplay::setDisplay()
{ 
   n_failureflag=0;
   PowerState=0x0000;
   ReadWriteMode=0x0001;

   if ( !LRMI_init() ) {
	n_failureflag=1;
 	throw "Initial LRMI failure!!\n";
   }
   ioperm(0, 1024, 1);
   iopl(3);
   memset(&r, 0, sizeof(r));
   r.eax = 0x4f10;
}

int setDisplay::normal()
{
  if ( n_failureflag )
  	return 0;
  	
  r.ebx = 0x0001;
  if (!LRMI_int(0x10, &r) ) 
      return 0;

  return 1;  
}

int setDisplay::standby()
{
  if ( n_failureflag )
  	return 0;
  
  r.ebx = 0x0101;
  if (!LRMI_int(0x10, &r) ) 
      return 0;

  return 1;   
}

int setDisplay::suspend()
{
  if ( n_failureflag )
  	return 0;
  
  r.ebx = 0x0201;
  if (!LRMI_int(0x10, &r) ) 
      return 0;

  return 1; 
}

int setDisplay::poweroff()
{
  if ( n_failureflag )
  	return 0;
  
  r.ebx = 0x0401;
  if (!LRMI_int(0x10, &r) ) 
      return 0;

  return 1; 
}

int setDisplay::reduced()
{
  if ( n_failureflag )
  	return 0;
  
  r.ebx = 0x0801;
  if (!LRMI_int(0x10, &r) ) 
      return 0;
  return 1; 
}

//show the display state
int setDisplay::getState()
{
  if ( n_failureflag )
  	return 0;
  
  r.ebx = 0x0002;
  if (!LRMI_int(0x10, &r) ) 
      return 0;
  
  if ( ( r.ebx && 0x1100 ) == 0x0000 )
  	return DISPLAYPOWERSTATE_NORMAL;
  else if ( ( r.ebx && 0x1100 ) == 0x0100 )
  	return DISPLAYPOWERSTATE_STANDBY;
  else if ( ( r.ebx && 0x1100 ) == 0x0200 )
	return DISPLAYPOWERSTATE_SUSPEND;
  else if ( ( r.ebx && 0x1100 ) == 0x00400 )
	return DISPLAYPOWERSTATE_POWEROFF;
  else if ( ( r.ebx && 0x1100 ) == 0x0800 )
	return DISPLAYPOWERSTATE_REDUCED;
  else
	return -1;
}

setDisplay::~setDisplay()
{
}

